#!/usr/bin/env bash

development = false

install_packages() {
  if [[ -f /usr/bin/pacman ]]; then
    sudo pacman -S clang make cmake fltk catch2

  elif [[ -f /usr/bin/apt ]]; then
    sudo apt install clang make cmake clang-tidy libfltk1.3 libfltk1.3-dev

    git clone https://github.com/catchorg/Catch2.git
    cd Catch2
    cmake -Bbuild -H. -DBUILD_TESTING=OFF
    sudo cmake --build build/ --target install
    cd ..

  elif [[ -f /usr/local/Homebrew ]]; then
    sudo brew install clang make cmake fltk catch2

    #some systems have --with-toolchain some dont, so we need to do this
    if ! sudo brew install llvm --with-toolchain; then
      sudo brew install llvm
    elif

    ln -s "/usr/local/opt/llvm/bin/clang-tidy" "/usr/local/bin/clang-tidy"
  fi
}

while [ -n "$1" ]; do
 
    case "$1" in
 
    -dev) development = true ;;
 
    *) echo "Option $1 not recognized" ;;
 
    esac
 
    shift
 
done

install_packages

echo "cloning repositories"
cd ..

if [ $development ]; then
  git clone ssh://git@gitlab.repo.digitech.hs-emden-leer.de:2222/link/projekte/ws19/vkvm-new/library.git
  git clone ssh://git@gitlab.repo.digitech.hs-emden-leer.de:2222/link/projekte/ws19/vkvm-new/shared-memory.git
  git clone ssh://git@gitlab.repo.digitech.hs-emden-leer.de:2222/link/projekte/ws19/vkvm-new/text-renderer.git
  git clone ssh://git@gitlab.repo.digitech.hs-emden-leer.de:2222/link/projekte/ws19/vkvm-new/gui.git
  git clone ssh://git@gitlab.repo.digitech.hs-emden-leer.de:2222/link/projekte/ws19/vkvm-new/terminal.git
  git clone ssh://git@gitlab.repo.digitech.hs-emden-leer.de:2222/link/projekte/ws19/vkvm-new/simple-draw.git
  git clone ssh://git@gitlab.repo.digitech.hs-emden-leer.de:2222/link/projekte/ws19/vkvm-new/demo.git
elif
  git clone https://gitlab.repo.digitech.hs-emden-leer.de/link/projekte/ws19/vkvm-new/library.git
  git clone https://gitlab.repo.digitech.hs-emden-leer.de/link/projekte/ws19/vkvm-new/shared-memory.git
  git clone https://gitlab.repo.digitech.hs-emden-leer.de/link/projekte/ws19/vkvm-new/text-renderer.git
  git clone https://gitlab.repo.digitech.hs-emden-leer.de/link/projekte/ws19/vkvm-new/gui.git
  git clone https://gitlab.repo.digitech.hs-emden-leer.de/link/projekte/ws19/vkvm-new/terminal.git
  git clone https://gitlab.repo.digitech.hs-emden-leer.de/link/projekte/ws19/vkvm-new/simple-draw.git
  git clone https://gitlab.repo.digitech.hs-emden-leer.de/link/projekte/ws19/vkvm-new/demo.git
fi

mkdir library/build
mkdir shared-memory/build
mkdir text-renderer/build
mkdir gui/build
mkdir terminal/build
mkdir simple-draw/build
mkdir demo/build




cd installation

echo "installation completed"
./build.sh
